"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var close_1 = __importDefault(require("react-icons/lib/fa/close"));
var styled_components_1 = __importDefault(require("styled-components"));
var Button_1 = __importDefault(require("../../components/Button"));
var Flex_1 = require("../../components/Flex");
var utils_1 = require("../../utils");
var Wrapper = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tborder-radius: ", ";\n\tborder: 1px solid ", ";\n\tbackground-color: ", ";\n\tcolor: ", ";\n"], ["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ",
    ";\n\tborder-radius: ", ";\n\tborder: 1px solid ", ";\n\tbackground-color: ",
    ";\n\tcolor: ", ";\n"])), function (props) {
    return utils_1.px(props.theme.space[2]) + " " + utils_1.px(props.theme.space[4]) + " " + utils_1.px(props.theme.space[2]) + " " + utils_1.px(props.theme.space[3]);
}, function (props) { return utils_1.px(props.theme.radius); }, function (props) { return utils_1.getColor(props, 'bg', 'main'); }, function (props) {
    return utils_1.getColor(props, 'bg', props.solid ? 'main' : 'light');
}, function (props) { return (props.solid ? 'white' : props.color); });
var DismissButton = styled_components_1.default(Button_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcolor: inherit;\n\tposition: absolute;\n\tmargin-top: 1px; /* This is used to normalize the icon position as it is displaced by a pixel */\n\ttop: ", ";\n\tright: ", ";\n"], ["\n\tcolor: inherit;\n\tposition: absolute;\n\tmargin-top: 1px; /* This is used to normalize the icon position as it is displaced by a pixel */\n\ttop: ",
    ";\n\tright: ", ";\n"])), function (props) {
    return props.baselineHeight
        ? utils_1.px(props.baselineHeight / 2)
        : utils_1.px(props.theme.space[3]);
}, function (props) { return utils_1.px(props.theme.space[3]); });
exports.DismissableContainer = function (_a) {
    var children = _a.children, onDismiss = _a.onDismiss, baselineHeight = _a.baselineHeight, solid = _a.solid, restProps = __rest(_a, ["children", "onDismiss", "baselineHeight", "solid"]);
    return (react_1.default.createElement(Wrapper, __assign({ solid: solid }, restProps),
        children,
        onDismiss && (react_1.default.createElement(DismissButton, { baselineHeight: baselineHeight, plain: true, onClick: onDismiss },
            react_1.default.createElement(close_1.default, null)))));
};
var templateObject_1, templateObject_2;
