import { __assign, __makeTemplateObject, __rest } from "tslib";
import React from 'react';
import FaClose from 'react-icons/lib/fa/close';
import styled from 'styled-components';
import Button from '../../components/Button';
import { Flex } from '../../components/Flex';
import { getColor, px } from '../../utils';
var Wrapper = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tborder-radius: ", ";\n\tborder: 1px solid ", ";\n\tbackground-color: ", ";\n\tcolor: ", ";\n"], ["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ",
    ";\n\tborder-radius: ", ";\n\tborder: 1px solid ", ";\n\tbackground-color: ",
    ";\n\tcolor: ", ";\n"])), function (props) {
    return px(props.theme.space[2]) + " " + px(props.theme.space[4]) + " " + px(props.theme.space[2]) + " " + px(props.theme.space[3]);
}, function (props) { return px(props.theme.radius); }, function (props) { return getColor(props, 'bg', 'main'); }, function (props) {
    return getColor(props, 'bg', props.solid ? 'main' : 'light');
}, function (props) { return (props.solid ? 'white' : props.color); });
var DismissButton = styled(Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcolor: inherit;\n\tposition: absolute;\n\tmargin-top: 1px; /* This is used to normalize the icon position as it is displaced by a pixel */\n\ttop: ", ";\n\tright: ", ";\n"], ["\n\tcolor: inherit;\n\tposition: absolute;\n\tmargin-top: 1px; /* This is used to normalize the icon position as it is displaced by a pixel */\n\ttop: ",
    ";\n\tright: ", ";\n"])), function (props) {
    return props.baselineHeight
        ? px(props.baselineHeight / 2)
        : px(props.theme.space[3]);
}, function (props) { return px(props.theme.space[3]); });
export var DismissableContainer = function (_a) {
    var children = _a.children, onDismiss = _a.onDismiss, baselineHeight = _a.baselineHeight, solid = _a.solid, restProps = __rest(_a, ["children", "onDismiss", "baselineHeight", "solid"]);
    return (React.createElement(Wrapper, __assign({ solid: solid }, restProps),
        children,
        onDismiss && (React.createElement(DismissButton, { baselineHeight: baselineHeight, plain: true, onClick: onDismiss },
            React.createElement(FaClose, null)))));
};
var templateObject_1, templateObject_2;
